// Code generated by go-swagger; DO NOT EDIT.

package enterprise

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDisableDataSourceCacheParams creates a new DisableDataSourceCacheParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDisableDataSourceCacheParams() *DisableDataSourceCacheParams {
	return &DisableDataSourceCacheParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDisableDataSourceCacheParamsWithTimeout creates a new DisableDataSourceCacheParams object
// with the ability to set a timeout on a request.
func NewDisableDataSourceCacheParamsWithTimeout(timeout time.Duration) *DisableDataSourceCacheParams {
	return &DisableDataSourceCacheParams{
		timeout: timeout,
	}
}

// NewDisableDataSourceCacheParamsWithContext creates a new DisableDataSourceCacheParams object
// with the ability to set a context for a request.
func NewDisableDataSourceCacheParamsWithContext(ctx context.Context) *DisableDataSourceCacheParams {
	return &DisableDataSourceCacheParams{
		Context: ctx,
	}
}

// NewDisableDataSourceCacheParamsWithHTTPClient creates a new DisableDataSourceCacheParams object
// with the ability to set a custom HTTPClient for a request.
func NewDisableDataSourceCacheParamsWithHTTPClient(client *http.Client) *DisableDataSourceCacheParams {
	return &DisableDataSourceCacheParams{
		HTTPClient: client,
	}
}

/*
DisableDataSourceCacheParams contains all the parameters to send to the API endpoint

	for the disable data source cache operation.

	Typically these are written to a http.Request.
*/
type DisableDataSourceCacheParams struct {

	// DataSourceUID.
	DataSourceUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the disable data source cache params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DisableDataSourceCacheParams) WithDefaults() *DisableDataSourceCacheParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the disable data source cache params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DisableDataSourceCacheParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the disable data source cache params
func (o *DisableDataSourceCacheParams) WithTimeout(timeout time.Duration) *DisableDataSourceCacheParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the disable data source cache params
func (o *DisableDataSourceCacheParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the disable data source cache params
func (o *DisableDataSourceCacheParams) WithContext(ctx context.Context) *DisableDataSourceCacheParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the disable data source cache params
func (o *DisableDataSourceCacheParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the disable data source cache params
func (o *DisableDataSourceCacheParams) WithHTTPClient(client *http.Client) *DisableDataSourceCacheParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the disable data source cache params
func (o *DisableDataSourceCacheParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDataSourceUID adds the dataSourceUID to the disable data source cache params
func (o *DisableDataSourceCacheParams) WithDataSourceUID(dataSourceUID string) *DisableDataSourceCacheParams {
	o.SetDataSourceUID(dataSourceUID)
	return o
}

// SetDataSourceUID adds the dataSourceUid to the disable data source cache params
func (o *DisableDataSourceCacheParams) SetDataSourceUID(dataSourceUID string) {
	o.DataSourceUID = dataSourceUID
}

// WriteToRequest writes these params to a swagger request
func (o *DisableDataSourceCacheParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param dataSourceUID
	if err := r.SetPathParam("dataSourceUID", o.DataSourceUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
