// Code generated by go-swagger; DO NOT EDIT.

package migrations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/grafana/grafana-openapi-client-go/models"
)

// NewCreateSessionParams creates a new CreateSessionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateSessionParams() *CreateSessionParams {
	return &CreateSessionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateSessionParamsWithTimeout creates a new CreateSessionParams object
// with the ability to set a timeout on a request.
func NewCreateSessionParamsWithTimeout(timeout time.Duration) *CreateSessionParams {
	return &CreateSessionParams{
		timeout: timeout,
	}
}

// NewCreateSessionParamsWithContext creates a new CreateSessionParams object
// with the ability to set a context for a request.
func NewCreateSessionParamsWithContext(ctx context.Context) *CreateSessionParams {
	return &CreateSessionParams{
		Context: ctx,
	}
}

// NewCreateSessionParamsWithHTTPClient creates a new CreateSessionParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateSessionParamsWithHTTPClient(client *http.Client) *CreateSessionParams {
	return &CreateSessionParams{
		HTTPClient: client,
	}
}

/*
CreateSessionParams contains all the parameters to send to the API endpoint

	for the create session operation.

	Typically these are written to a http.Request.
*/
type CreateSessionParams struct {

	// Body.
	Body *models.CloudMigrationSessionRequestDTO

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create session params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateSessionParams) WithDefaults() *CreateSessionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create session params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateSessionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create session params
func (o *CreateSessionParams) WithTimeout(timeout time.Duration) *CreateSessionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create session params
func (o *CreateSessionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create session params
func (o *CreateSessionParams) WithContext(ctx context.Context) *CreateSessionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create session params
func (o *CreateSessionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create session params
func (o *CreateSessionParams) WithHTTPClient(client *http.Client) *CreateSessionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create session params
func (o *CreateSessionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create session params
func (o *CreateSessionParams) WithBody(body *models.CloudMigrationSessionRequestDTO) *CreateSessionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create session params
func (o *CreateSessionParams) SetBody(body *models.CloudMigrationSessionRequestDTO) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateSessionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
